package model

import pasturePb "gitee.com/xuyiping_admin/go_proto/proto/go/backend/cow"

const (
	AFIMilk = "afimilk"
	GEA     = "gea"
	AFI     = "afi"
)

const (
	IsExtra0 = iota
	IsExtra1
	IsExtra2
	IsExtra3
)

type MilkHall struct {
	Id            int64                 `json:"id"`
	PastureId     int64                 `json:"pasture_id"`
	Name          string                `json:"name"`
	Brand         string                `json:"brand"`
	Kind          string                `json:"kind"`
	Field         int32                 `json:"field"`
	IsExtraUpdate int32                 `json:"isExtraUpdate"`
	IsShow        pasturePb.IsShow_Kind `json:"is_show"`
	CreatedAt     int64                 `json:"created_at"`
	UpdatedAt     int64                 `json:"updated_at"`
}

func (m *MilkHall) TableName() string {
	return "milk_hall"
}

type MilkHallBody struct {
	MilkHallNumber string        `json:"milkHallNumber"`
	Brand          string        `json:"brand"`
	Content        []interface{} `json:"content"`
	FarmId         string        `json:"farmId"`
}

type AFIMilkHallOriginal struct {
	UID                     int     `json:"uid"`
	SessionNumber           int32   `json:"sessionNumber"`
	SessionDate             string  `json:"sessionDate"`
	StallNumber             int64   `json:"stallNumber"`
	AnimalID                string  `json:"animalID,omitempty"` // 使用 omitempty 忽略空值
	GroupNumber             int     `json:"groupNumber,omitempty"`
	Yield                   int64   `json:"yield"`
	Yield2Minutes           int     `json:"yield2Minutes,omitempty"`
	Yield2MinutesPercentage float64 `json:"yield2MinutesPercentage,omitempty"`
	MilkingTime             int     `json:"milkingTime,omitempty"`
	FlowRate0To15           int64   `json:"flowRate_0To15,omitempty"`
	FlowRate15To30          int64   `json:"flowRate_15To30,omitempty"`
	FlowRate30To60          int64   `json:"flowRate_30To60,omitempty"`
	FlowRate60To120         int64   `json:"flowRate_60To120,omitempty"`
	HasKickoffs             bool    `json:"hasKickoffs"`
	TotalAttachments        int32   `json:"totalAttachments,omitempty"`
	IrregularDetachments    int     `json:"irregularDetachments,omitempty"`
	Amt1                    int32   `json:"amt1,omitempty"`
	DetachmentReason1       int     `json:"detachmentReason1,omitempty"`
	Yield1                  int     `json:"yield1,omitempty"`
	Amt2                    int     `json:"amt2,omitempty"`
	DetachmentReason2       int     `json:"detachmentReason2,omitempty"`
	Yield2                  int     `json:"yield2,omitempty"`
	Amt3                    int     `json:"amt3,omitempty"`
	DetachmentReason3       int     `json:"detachmentReason3,omitempty"`
	Yield3                  int     `json:"yield3,omitempty"`
	LowFlowRateTime         int32   `json:"lowFlowRateTime,omitempty"`
	RemovalFlowRate         int     `json:"removalFlowRate,omitempty"`
	PeakFlowRateTime        int     `json:"peakFlowRateTime,omitempty"`
	PeakFlowRate            int32   `json:"peakFlowRate,omitempty"`
	MilkingBimodality       bool    `json:"milkingBimodality,omitempty"`
}

type AfiHallOriginal struct {
	XmilkDate        string  `json:"xmilkDate"`
	Starttimes       string  `json:"starttimes"`
	MilkDateTime     string  `json:"milkDateTime"`
	Attachtimes      string  `json:"attachtimes"`
	Detachtimes      string  `json:"detachtimes"`
	Endtimes         string  `json:"endtimes"`
	Nattach          int     `json:"nattach"`
	Shifts           int     `json:"shifts"`
	Load             int     `json:"load"`
	DetacherAddress  int     `json:"detacher_address"`
	Varcowcode       string  `json:"varcowcode"`
	Eidstation       int     `json:"eidstation"`
	MilkWeight       float32 `json:"milk_weight"`
	MilkConductivity int     `json:"milk_conductivity"`
	Duration         float32 `json:"duration"`
	KickOffs         int     `json:"kickOffs"`
	ManualDetach     int     `json:"manualDetach"`
	PeakFlow         float32 `json:"peakFlow"`
	PeakFlowTime     int     `json:"peakFlowTime"`
	TakeOffFlow      float32 `json:"takeOffFlow"`
	LowFlowTime      int     `json:"LowFlowTime"`
	Flow0to15        int     `json:"flow0to15"`
	Flow15to30       int     `json:"flow15to30"`
	Flow30to60       int     `json:"flow30to60"`
	Flow60to120      int     `json:"flow60to120"`
}
